org.apache.lucene.search.spans

## Class SpanNotQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.spans.SpanQuery
    - - org.apache.lucene.search.spans.SpanNotQuery

-     public final class SpanNotQuery
      extends SpanQuery

  Removes matches which overlap with another SpanQuery or which are within x tokens before or y tokens after another SpanQuery.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `SpanNotQuery.SpanNotWeight`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SpanNotQuery(SpanQuery include, SpanQuery exclude)` Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude`.
    `SpanNotQuery(SpanQuery include, SpanQuery exclude, int dist)` Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude` within `dist` tokens of `include`.
    `SpanNotQuery(SpanQuery include, SpanQuery exclude, int pre, int post)` Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude` within `pre` tokens before or `post` tokens of `include`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `SpanWeight` | `createWeight(IndexSearcher searcher, boolean needsScores, float boost)` Expert: Constructs an appropriate Weight implementation for this query.
    `boolean` | `equals(Object other)` Returns true iff `o` is equal to this.
    `SpanQuery` | `getExclude()` Return the SpanQuery whose matches must not overlap those returned.
    `String` | `getField()` Returns the name of the field matched by this query.
    `SpanQuery` | `getInclude()` Return the SpanQuery whose matches are filtered.
    `int` | `hashCode()` Override and implement query hash code properly in a subclass.
    `Query` | `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
    `String` | `toString(String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.

    - ### Methods inherited from class org.apache.lucene.search.spans.SpanQuery

      `getTermContexts, getTermContexts`

    - ### Methods inherited from class org.apache.lucene.search.Query

      `classHash, sameClassAs, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SpanNotQuery

          public SpanNotQuery(SpanQuery include,
                              SpanQuery exclude)

      Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude`.

    - #### SpanNotQuery

          public SpanNotQuery(SpanQuery include,
                              SpanQuery exclude,
                              int dist)

      Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude` within `dist` tokens of `include`. Inversely, a negative `dist` value may be used to specify a certain amount of allowable overlap.

    - #### SpanNotQuery

          public SpanNotQuery(SpanQuery include,
                              SpanQuery exclude,
                              int pre,
                              int post)

      Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude` within `pre` tokens before or `post` tokens of `include`. Inversely, negative values for `pre` and/or `post` allow a certain amount of overlap to occur.

  - ### Method Detail

    - #### getInclude

          public SpanQuery getInclude()

      Return the SpanQuery whose matches are filtered.

    - #### getExclude

          public SpanQuery getExclude()

      Return the SpanQuery whose matches must not overlap those returned.

    - #### getField

          public String getField()

      Description copied from class: `SpanQuery`
      Returns the name of the field matched by this query.
      Specified by:
        `getField` in class `SpanQuery`

    - #### toString

          public String toString(String field)

      Description copied from class: `Query`
      Prints a query to a string, with `field` assumed to be the default field and omitted.
      Specified by:
        `toString` in class `Query`

    - #### createWeight

          public SpanWeight createWeight(IndexSearcher searcher,
                                         boolean needsScores,
                                         float boost)
                                  throws IOException

      Description copied from class: `Query`
      Expert: Constructs an appropriate Weight implementation for this query.

      Only implemented by primitive queries, which re-write to themselves.

      Specified by:
        `createWeight` in class `SpanQuery`
        `needsScores` - True if document scores (`Scorer.score()`) are needed.
        `boost` - The boost that is propagated by the parent queries.
      Throws:
        `IOException`

    - #### rewrite

          public Query rewrite(IndexReader reader)
                        throws IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.
      Overrides:
        `rewrite` in class `Query`
      Throws:
        `IOException`

    - #### equals

          public boolean equals(Object other)

      Returns true iff `o` is equal to this.
      Specified by:
        `equals` in class `Query`
      See Also:
        `Query.sameClassAs(Object)`, `Query.classHash()`

    - #### hashCode

          public int hashCode()

      Description copied from class: `Query`
      Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
      Specified by:
        `hashCode` in class `Query`
      See Also:
        `Query.equals(Object)`

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.